RecountFu = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceDB-2.0", "FuBarPlugin-2.0", "AceEvent-2.0"); 
local L = AceLibrary("AceLocale-2.2"):new("RecountFu"); 
local Tablet = AceLibrary("Tablet-2.0");
local Crayon = AceLibrary("Crayon-2.0");

L:RegisterTranslations("enUS", function() return { 
   ["tabletHint1"] = "Left-Click to toggle window visibility.", 
   ["tabletHint2"] = "Double-Left-Click to reset window position.",  
   ["tabletHint3"] = "Alt-Click to reset data.",  
   ["labelName"] = "Recount",
   ["recountFuMenuTitle"] = "Recount Options",
   ["menuOptionChooseViewTitle"] = "Choose View Mode",
   ["menuOptionChooseViewDesc"] = "Select which report to view in the Recount Window",
   ["Session"] = true,
   ["Last Fight"] = true,
   ["Total"] = true,
   ["Per Second"] = true,
   ["Damage Done"] = true,
   ["Healing Done"] = true,
   ["Damage Taken"] = true,
   ["Healing Taken"] = true,
   ["No Damage Change"] = true,
   ["Heal Summary"] = true,
   ["Damage Summary"] = true,
} end); 

L:RegisterTranslations("deDE", function() return { 
    ["tabletHint1"] = "Linksklick um das Recount-Fenster ein-/auszublenden.", 
    ["tabletHint2"] = "Doppel-Linksklick um die Fensterposition zur\195\188ckzusetzen.",      
    ["tabletHint3"] = "Alt-Click um Daten zu resetten.",  
    ["labelName"] = "Recount",
    ["recountFuMenuTitle"] = "Recount Optionen",
    ["menuOptionChooseViewTitle"] = "Ansichtsmodus w\195\164hlen",
    ["menuOptionChooseViewDesc"] = "Ausw\195\164hlen welcher Report im Recount-Fenster angezeigt werden soll.",
} end);

L:RegisterTranslations("zhTW", function() return { 
   ["tabletHint1"] = "點擊左鍵切換視窗顯示", 
   ["tabletHint2"] = "雙擊左鍵重置式窗位置",  
   ["tabletHint3"] = "Alt-點擊重置資料",  
   ["labelName"] = "Recount",
   ["recountFuMenuTitle"] = "Recount 選項",
   ["menuOptionChooseViewTitle"] = "選擇觀看模式",
   ["menuOptionChooseViewDesc"] = "選擇何種報告顯示於 Recount 視窗",
   ["Session"] = "本次",
   ["Last Fight"] = "最後一次戰鬥",
   ["Total"] = "總計",
   ["Per Second"] = "每秒",
   ["Damage Done"] = "輸出傷害",
   ["Healing Done"] = "輸出治療",
   ["Damage Taken"] = "承受傷害",
   ["Healing Taken"] = "接受治療",
   ["No Damage Change"] = "輸出傷害與受到治療持平",
   ["Heal Summary"] = "受到治療大於輸出傷害",
   ["Damage Summary"] = "輸出傷害大於受到治療",
} end); 

L:RegisterTranslations("zhCN", function() return { 
   ["tabletHint1"] = "左键点击 - 显示/隐藏 Recount.", 
   ["tabletHint2"] = "双击 - 重置 Recount 位置.",  
   ["tabletHint3"] = "Alt 点击 - 重置数据.",  
   ["labelName"] = "Recount",
   ["recountFuMenuTitle"] = "Recount 设置",
   ["menuOptionChooseViewTitle"] = "选择显示模式",
   ["menuOptionChooseViewDesc"] = "选择在 Recount 中显示报告类别",
   ["Session"] = "本次连接",
   ["Last Fight"] = "最后一次战斗",
   ["Total"] = "总计",
   ["Per Second"] = "每秒",
   ["Damage Done"] = "输出伤害",
   ["Healing Done"] = "输出治疗",
   ["Damage Taken"] = "承受伤害",
   ["Healing Taken"] = "接受治疗",
   ["No Damage Change"] = "输出伤害与受到治疗持平",
   ["Heal Summary"] = "受到治疗大于输出伤害",
   ["Damage Summary"] = "输出伤害大于受到治疗",
} end); 

RecountFu.hasIcon = true; 
RecountFu.defaultPosition = "RIGHT"; 
RecountFu:RegisterDB("RecountFuDB"); 

RecountFu:RegisterDefaults("profile", {
    text = {
        dps_type = "Last Fight",
        show_dps = false,
        update_time = 0.5,
        show_combat_time = false
    }
})

function RecountFu:OnTextUpdate()
  self:DoTextUpdate()
end

function RecountFu:OnTooltipUpdate() 
    cat = Tablet:AddCategory(
		'columns', 3,
        'text',L["Session"]
	)
    self:GetTooltipSection(cat,"OverallData")
    cat = Tablet:AddCategory(
		'columns', 3,
        'text',L["Last Fight"]
	)
    self:GetTooltipSection(cat,"Fight1")
   Tablet:SetHint(L["tabletHint1"] .. "\n" .. L["tabletHint2"].. "\n" .. L["tabletHint3"]);
end 


function RecountFu:GetTooltipSection(cat,tableToUse)
    cat:AddLine({text = "", text2=L["Total"], text3=L["Per Second"]})
    cat:AddLine(self:GetTooltipLine(L["Damage Done"],tableToUse,"Damage"))
    cat:AddLine(self:GetTooltipLine(L["Healing Done"],tableToUse,"Healing"))
    cat:AddLine(self:GetTooltipLine(L["Damage Taken"],tableToUse,"DamageTaken"))
    cat:AddLine(self:GetTooltipLine(L["Healing Taken"],tableToUse,"HealingTaken"))
    cat:AddLine(self:GetDamageHealingSummaryTooltipLine(tableToUse))
end

function RecountFu:GetTooltipLine(title,tableToUse,valueToUse)
    line = {}
    line.text = title
    line.text2 = self:getValue(tableToUse,valueToUse)
    line.text3 = self:getValuePerSecond(tableToUse,valueToUse)
    return line
end

function RecountFu:GetDamageHealingSummaryTooltipLine(tableToUse)
    local sumDmgHeal = self:getValue(tableToUse,"HealingTaken")-self:getValue(tableToUse,"DamageTaken")
    if sumDmgHeal == 0 then
        line.text = L["No Damage Change"]
        line.text2 = ""
    elseif sumDmgHeal >0 then
        line.text = L["Heal Summary"]
        line.text2 = sumDmgHeal
    else
        line.text = L["Damage Summary"]
        line.text2 = sumDmgHeal*-1
    end
    line.text3 = ""
    return line
end

function RecountFu:OnClick()
		if (IsAltKeyDown()) then
			Recount:ResetData();
			return
		end		
 
    if (Recount.MainWindow:IsShown()) then 
        Recount.MainWindow:Hide() 
    else 
        Recount.MainWindow:Show() 
    end    
end 

function RecountFu:OnDoubleClick()
    Recount:ResetPositions(); 
    Recount.MainWindow:Show(); 
end

function RecountFu:OnEnable()
    self:UpdateTimeChanged()
    self.LastFightDPS =0
    self.CurrentFightDPS=0
end

function RecountFu:UpdateTimeChanged()
    if(self:IsEventRegistered(self.name.."TEXT_UPDATE")) then
        self:UnregisterEvent(self.name.."TEXT_UPDATE")
    end
    if(RecountFu.db.profile.text.show_dps) then
        self:ScheduleRepeatingEvent(self.name.."TEXT_UPDATE",RecountFu.DoTextUpdate,RecountFu.db.profile.text.update_time,self)
    end
end

function RecountFu:getValuePerSecond(tableToUse,valueToUse)
	playerName = UnitName("player")
    Epsilon=0.000000000000000001
    combatData = Recount.db2.char.combatants[playerName].Fights[tableToUse]
    return math.floor(10*combatData[valueToUse]/(combatData.ActiveTime+Epsilon)+0.5)/10
end

function RecountFu:getRaidValuePerSecond(tableToUse)
    Epsilon=0.000000000000000001
	dps = 0
	for _,data in pairs(Recount.db2.char.combatants) do
		if  data.type=="Self" or data.type=="Grouped" or data.type=="Pet" then
			dps = dps + 10*data.Fights[tableToUse].Damage/(data.Fights[tableToUse].ActiveTime+Epsilon)
		end
	end
	return math.floor(dps+0.5)/10
end


function RecountFu:getValue(tableToUse,valueToUse)
    playerName = UnitName("player")
    combatData = Recount.db2.char.combatants[playerName].Fights[tableToUse]
    return combatData[valueToUse]
end

function RecountFu:getTimeInCombat(tableToUse)
    Epsilon=0.000000000000000001
    return math.floor(10*(self:getValue(tableToUse,"ActiveTime")+Epsilon))/10
end

function RecountFu:DoTextUpdate()
    local text = ""
    if(self:IsTextShown()) then
        if(RecountFu.db.profile.text.show_dps) then
            text = text ..self:GetFubarDPS()
        end
        if(RecountFu.db.profile.text.show_combat_time) then
            text = text ..self:GetFubarTimeInCombat()
        end
    else
        text = Crayon:White(L["labelName"])  
    end
    self:SetText(text)
end

function RecountFu:GetFubarDPS()
    text = Crayon:Orange(" DPS:")
    if(RecountFu.db.profile.text.dps_type == "LastFight") then
        if(Recount.InCombat) then
			if (RecountFu.db.profile.text.dps_raid == "RaidDPS") then
				self.CurrentFightDPS = self:getRaidValuePerSecond("CurrentFightData")
			else
				self.CurrentFightDPS = self:getValuePerSecond("CurrentFightData","Damage")
			end
            text = text .. Crayon:Red(self.CurrentFightDPS)
        else
			if (RecountFu.db.profile.text.dps_raid == "RaidDPS") then
				self.LastFightDPS = self:getRaidValuePerSecond("Fight1")
			else
				self.CurrentFightDPS = self:getValuePerSecond("Fight1","Damage")
			end
            if(self.LastFightDPS == 0) then
                if(self.CurrentFightDPS > 0) then
                    text = text .. Crayon:Yellow(self.CurrentFightDPS)
                else
                    text = text .. Crayon:Blue("-")
                end
            else
                text = text .. Crayon:White(self.LastFightDPS)
            end
        end              
    elseif(RecountFu.db.profile.text.dps_type == "Overall") then
        text = text ..Crayon:Green(self:getRaidValuePerSecond("OverallData"))
    end
    return text
end

function RecountFu:GetFubarTimeInCombat()
    text = Crayon:Orange(" Time:")
    if(Recount.InCombat) then
        timeInCombat=self:getTimeInCombat("CurrentFightData")
    else
        timeInCombat=self:getTimeInCombat("Fight1")
    end
    if(timeInCombat == 0) then
        text = text .. Crayon:Blue("-")
    else
        if(Recount.InCombat) then
            text = text .. Crayon:Red(timeInCombat)
        else
            text = text .. Crayon:White(timeInCombat)
        end
    end
    return text
end